/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ESPECANIMAL                                              */
/* Tabela : ESPECANIMAL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 03/12/2004 - JOAO PAULO REIS                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ESPECANIMAL' and
            type = 'TR'             and
            u.uid = o.uid           and
            u.name = USER)
   DROP TRIGGER DTULTATU_ESPECANIMAL
GO

CREATE TRIGGER DTULTATU_ESPECANIMAL
ON ESPECANIMAL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                         (SELECT 'ESPECANIMAL', null, 'CDESPEANIMAL ='+ CDESPEANIMAL + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ESPECANIMAL
      SET DTULTATUESAN = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ESPECANIMAL.CDESPEANIMAL,0) = ISNULL(INSERTED.CDESPEANIMAL,0)) AND
            (ISNULL(ESPECANIMAL.NMESPEANIMAL,0) = ISNULL(INSERTED.NMESPEANIMAL,0))
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ESPECANIMAL','4.05.109';
GO

